// Bentigt GLUT!
// Fr Dev-C++ (also Mingw32) siehe http://sites.netscape.net/ptrpck/glut.htm
// mit GLUT linken: Project/Project options/Further object files or linker options:
// -lopengl32 -lglu32 -lglut32

// Korrekturen fr GLUT in Dev-C++:
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE

#include <gl/glut.h>
#include <math.h>
#include <stdlib.h>

const int size=400; // Kantenlnge

// aktuelle Werte, automatisch auf null
double u[size][size];
// aktuelle Werte fr erste Ableitung (fr Wellengl.);
// zweite Variable fr Reaktions-Diff.-Gl.
double ud[size][size]; 
unsigned char pic[size*size*3];

int recentButton = 0; // zuletzt gedrckte Maustaste

unsigned char clampToByte(double c)
{
    if(c>=1.0) return 255;
    if(c<=0.0) return 0;
    return (unsigned int)(c*255.0);
}

void recalc()
{
    // Wrmeleitungsgleichung
    double v[size][size] = {0.0}; // nchste Werte; besser nicht jedes Mal neu anlegen
    int x, y;
    for(x=1; x<size-1; x++)
    {
        for(y=1; y<size-1; y++)
        {
            double laplace = u[x-1][y] + u[x][y-1] + u[x+1][y] + u[x][y+1] - 4.0*u[x][y];
            v[x][y] = u[x][y] + 0.1*laplace;
        }
    }
    for(x=0; x<size; x++)
    {
        for(y=0; y<size; y++)
        {
            u[x][y] = v[x][y]; // besser wre umgebogener Zeiger
        }
    }
    // Ende Wrmeleitungsgleichung

    /*
    // Wellengleichung dumm
    double vd[size][size];
    int x, y;
    for(x=1; x<size-1; x++)
    {
        for(y=1; y<size-1; y++)
        {
            double laplace = u[x-1][y] + u[x][y-1] + u[x+1][y] + u[x][y+1] - 4.0*u[x][y];
            vd[x][y] = ud[x][y] + 0.1*laplace;
            u[x][y] += 0.1*vd[x][y];
        }
    }
    for(x=0; x<size; x++)
    {
        for(y=0; y<size; y++)
        {
            ud[x][y] = vd[x][y]; // besser wre umgebogener Zeiger
        }
    }
    // Ende Wellengleichung dumm
    */

    /*
    // Wellengleichung Verlet
    double v[size][size]; // mssen wir diesmal initialisieren
    int x, y;
    for(x=0; x<size; x++)
    {
        for(y=0; y<size; y++)
        {
            v[x][y] = 0.0;
        }
    }
    for(x=1; x<size-1; x++)
    {
        for(y=1; y<size-1; y++)
        {
            double laplace = u[x-1][y] + u[x][y-1] + u[x+1][y] + u[x][y+1] - 4.0*u[x][y];
            v[x][y] = u[x][y] + 0.05*ud[x][y];
            ud[x][y] += 0.1*laplace;
        }
    }
    for(x=0; x<size; x++)
    {
        for(y=0; y<size; y++)
        {
            u[x][y] = v[x][y] + 0.05*ud[x][y];
        }
    }
    // Ende Wellengleichung Verlet
    */

    /*
    // Turings Reaktions-Diffusions-Gleichung, dumm gerechnet: explodiert
    double v[size][size];
    double vd[size][size];
    int x, y;
    for(x=0; x<size; x++)
    {
        for(y=0; y<size; y++)
        {
            v[x][y] = 0.0;
            vd[x][y] = 0.0;
        }
    }
    for(x=1; x<size-1; x++)
    {
        for(y=1; y<size-1; y++)
        {
            double laplaceU = u[x-1][y] + u[x][y-1] + u[x+1][y] + u[x][y+1] - 4.0*u[x][y];
            double laplaceUD = ud[x-1][y] + ud[x][y-1] + ud[x+1][y] + ud[x][y+1] - 4.0*ud[x][y];
            v[x][y] = u[x][y] + 1.7*(0.0125*(16.0-(u[x][y]+4.0)*(ud[x][y]+4.0)) + 0.125*laplaceU);
            vd[x][y] = ud[x][y] + 1.7*(0.0125*((u[x][y]+4.0)*(ud[x][y]+4.0) - ud[x][y]-4.0 - 12.0 + 0.2*(rand()/(double)RAND_MAX) - 0.1) + 0.03125*laplaceUD);
        }
    }
    for(x=0; x<size; x++)
    {
        for(y=0; y<size; y++)
        {
            u[x][y] = v[x][y];
            ud[x][y] = vd[x][y];
        }
    }
    // Ende Turings Reaktions-Diffusions-Gleichung
    */
}

void renderScene()
{
    glClear(GL_COLOR_BUFFER_BIT);
    int x, y;
    for(x=0; x<size; x++)
    {
        for(y=0; y<size; y++)
        {
            int index = (x+size*y)*3;
            pic[index  ] = clampToByte(u[x][y]); // Rot
            pic[index+1] = clampToByte(0.3*(1.0-u[x][y])); // Grn
            pic[index+2] = clampToByte(1.0-u[x][y]); // Blau
        }
    }
    glDrawPixels(size, size, GL_RGB, GL_UNSIGNED_BYTE, pic);
    glutSwapBuffers();

    recalc();
    glutPostRedisplay();
}

void drawDot(int x, int y)
{
    int x1, y1;
    for(x1=x-4; x1<=x+4; x1++)
    {
        if(x1<0) break;
        if(x1>=size) break;
        for(y1=y-4; y1<=y+4; y1++)
        {
            if(y1<0) break;
            if(y1>=size) break;
            u[x1][y1] += exp(-0.2*((x1-x)*(x1-x)+(y1-y)*(y1-y)));
        }
    }
}

void mouseFunc(int button, int state, int x, int y)
{
    recentButton = button;
    if(button==GLUT_LEFT_BUTTON && state==GLUT_DOWN)
    {
        drawDot(x, size-y); // y = Bildschirmkoordinate!
    }
}

void motionFunc(int x, int y)
{
    if(recentButton == GLUT_LEFT_BUTTON)
    {
        drawDot(x, size-y); // y = Bildschirmkoordinate!
    }
    glutPostRedisplay();
}

void changeSize(GLsizei w, GLsizei h)
{
    glViewport(0, 0, w, h);
}

int main(int argc, char* argv[])
{
    glutInit(&argc, argv);

    glutInitWindowSize(size, size);
    glutInitWindowPosition(30, 30);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
    glutCreateWindow("partielle Differentialgleichungen");
    glutDisplayFunc(renderScene);
    glutReshapeFunc(changeSize);
    glutMouseFunc(mouseFunc);
    glutMotionFunc(motionFunc);

    glutMainLoop();

    return 0; // nie erreicht
}
